/*
* -myapp commandline handler; starts up My App.
*/

 Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

 const nsICommandLineHandler = Components.interfaces.nsICommandLineHandler;
 const nsIWindowWatcher      = Components.interfaces.nsIWindowWatcher;

 var consoleService = Components
  .classes['@mozilla.org/consoleservice;1']
  .getService( Components.interfaces.nsIConsoleService );

 function recordMessage( message ) {
  consoleService.logStringMessage("esc: " + message  + "\n");
 }

/*
* Classes
*/

function escCLH() { 
};
 
escCLH.prototype = {


   contractID:  "@redhat.com/esc-clh;1",
   classID:  Components.ID("{36c65861-52a8-4ce9-aa3b-235b88216ed4}"),

   _xpcom_categories: [{  
    category: "command-line-handler",  
                 entry: "m-escCLH"  
    }], 

   /* nsISupports */

   QueryInterface : XPCOMUtils.generateQI([nsICommandLineHandler]),


   /* nsICommandLineHandler */

   handle : function clh_handle(cmdLine) {
       var args = new Object();
       args.urlopt = false;

       recordMessage("handle command line");

       try {

           var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
           var win = wm.getMostRecentWindow(null);

           var showUsage = cmdLine.handleFlag("usage",false);

           recordMessage("ShowUsage flag: " + showUsage);
           if(showUsage) {
               cmdLine.preventDefault = true;
           }

           if(win)
           {
               recordMessage("Subsequent command invocation. Launch appropriate  page.");
               if(showUsage) 
               {
                   recordMessage("About to show usage.");
                   win.ShowUsage();
                   return;
               }
               var locName = win.location.toString();

               recordMessage("Base window . " + locName);

               win.SelectESCPageCMDLine();

               recordMessage("Done command line handling...");
               return;
           }
           
           var chromeURI = "chrome://esc/content/hiddenWindow.xul";

           recordMessage(chromeURI);

           var wwatch = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                         .getService(nsIWindowWatcher);
           win = wwatch.openWindow(null, chromeURI, "_blank",
                     "chrome,dialog,height=-1,width=-1,popup=yes", cmdLine);

       }
       catch(e) {
           recordMessage("Error in setting up ESC command line handler." + e.toString);
       }

   },

   helpInfo : "  -esc  Open ESC.\n",

 };

 /* Module initialisation */

var NSGetFactory = XPCOMUtils.generateNSGetFactory([escCLH]);
